=== debian/changelog ===
pocl (0.13-9) unstable; urgency=medium

  * Work around using clang-3.8 with libstdc++-7-dev.  (Closes: #853620)
  * Update symbols files.
  * Switch to debhelper compat level 10.
  * Bump Standards-Version to 4.0.1.
  * Raise Priority to optional.
  * Support nodoc build.
  * Do not mark the -dev packages as Multi-Arch: foreign.
  * Move kernel-<triplet>.bc from libpocl1-common into libpocl1.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 07 Aug 2017 04:57:35 +0200

pocl (0.13-8) unstable; urgency=medium

  * Enable more hardening.
  * Reduce superfluous dependencies by linking with --as-needed.
  * Update symbols files.
  * Update lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 10 Oct 2016 13:38:39 +0200

pocl (0.13-7) unstable; urgency=medium

  * Update symbols files.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 09 Sep 2016 19:51:19 +0200

pocl (0.13-6) unstable; urgency=medium

  * Update symbols files.  (Closes: #835690, #836219)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 06 Sep 2016 14:55:01 +0200

pocl (0.13-5) unstable; urgency=medium

  * Build-depend on the llvm-3.8 release version.
  * Update symbols files.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 11 Jul 2016 04:24:40 +0200

pocl (0.13-4) unstable; urgency=medium

  * Use CLOCK_UPTIME_FAST on kFreeBSD.
  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 03 Jul 2016 16:17:52 +0200

pocl (0.13-3) experimental; urgency=medium

  * Switch to llvm 3.8.
  * Update symbols files for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 22 Jun 2016 14:37:21 +0200

pocl (0.13-2) unstable; urgency=medium

  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 22 Jun 2016 11:40:19 +0200

pocl (0.13-1) experimental; urgency=medium

  * New upstream release.  (Closes: #820480)
  * Refresh llvm-system-libs.patch, new upstream only supports llvm 3.7/3.8.
  * Remove fix-image-args.patch, fixed upstream.
  * glibc-2.23.patch: New, add support for glibc 2.23.
  * Update symbols files for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 15 Jun 2016 18:55:21 +0200

pocl (0.12-6) unstable; urgency=medium

  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 14 Jun 2016 20:11:10 +0200

pocl (0.12-5) experimental; urgency=medium

  * Switch to llvm 3.7.
  * Update symbols files for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Jun 2016 10:26:04 +0200

pocl (0.12-4) unstable; urgency=medium

  * Update symbols files.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 08 Jun 2016 02:36:14 +0200

pocl (0.12-3) unstable; urgency=medium

  * Fix OpenCL headers for GNU/Hurd.
  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 28 May 2016 17:17:37 +0200

pocl (0.12-2) experimental; urgency=medium

  * Add B-D: sphinx-common for binary-arch builds with 'dh --with sphinxdoc'.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 May 2016 20:32:16 +0200

pocl (0.12-1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Update symbols files for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 09 May 2016 14:44:03 +0200

pocl (0.11-5) unstable; urgency=medium

  * Work around clang failing to find sys/cdefs.h on !linux.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 27 May 2016 12:29:56 +0200

pocl (0.11-4) unstable; urgency=medium

  * Add B-D: sphinx-common for binary-arch builds with 'dh --with sphinxdoc'.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 17 May 2016 12:45:38 +0200

pocl (0.11-3) unstable; urgency=medium

  * Update symbols files.
  * Provide documentation package (pocl-doc), thanks to Ghislain Vaillant.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 08 May 2016 02:57:38 +0200

pocl (0.11-2) unstable; urgency=medium

  * Make the B-D on clang versioned to match llvm.
  * Drop superfluous B-D.
  * Fix testsuite failure on i386.  (Closes: #822563)
  * Switch back target cpu to pentium3 on any-i386.
  * Fix arm64 detection.  (Closes: #787686)
  * Move libpocl1-common to section utils.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 27 Apr 2016 10:17:50 +0200

pocl (0.11-1) experimental; urgency=medium

  [ Vincent Danjean ]
  * New upstream version  (Closes: #795321)
  * Switch to llvm-3.6  (Closes: #803652)
  * Fix "FTBFS on arm64" by targeting llvm arch to cortex-a53 on arm64
    (Closes: #787686)
  * Fix "vcs-browser field does not work" by fixing URL in debian/control
    (Closes: #775844)

  [ Andreas Beckmann ]
  * Use a temporary, writable $HOME while running the testsuite.
  * Show the full tests/testsuite.log on testsuite failures.
  * Drop the -dbg package in favor of autogenerated -dbgsym packages.
  * Update symbols files for amd64 and i386.
  * llvm-config --system-libs is only needed with static llvm.
  * Fix detection of image and sampler arguments, thanks to James Price.
    (Closes: #799322)
  * Put package under "Debian OpenCL Maintainers" team maintenance.
  * Add Vincent Danjean and myself to Uploaders.
  * Bump Standards-Version to 3.9.8 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Mon, 25 Apr 2016 09:49:29 +0200

pocl (0.10-12) experimental; urgency=medium

  * Update again symbol file for armel
  * apply partial fix for armhf (only one test fail, due to neon instruction)

 -- Vincent Danjean <vdanjean@debian.org>  Sun, 02 Nov 2014 01:36:13 +0100

pocl (0.10-11) experimental; urgency=medium

  * Correctly fix FreeBSD include
  * Update symbols file

 -- Vincent Danjean <vdanjean@debian.org>  Mon, 27 Oct 2014 12:31:47 +0100
