=== debian/control ===
Source: pocl
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Vincent Danjean <vdanjean@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10),
 pkg-config,
 libhwloc-dev,
 libltdl-dev,
 ocl-icd-dev (>= 2.2.3),
 ocl-icd-libopencl1 (>= 2.2.3),
 ocl-icd-opencl-dev,
 clang-3.8,
 llvm-3.8-dev (>= 1:3.8),
 libclang-3.8-dev,
 pkg-kde-tools,
 sphinx-common,
Build-Depends-Indep:
 python-sphinx,
Standards-Version: 4.0.1
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/pocl.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/pocl.git
Homepage: http://portablecl.org

Package: pocl-opencl-icd
Architecture: any
Depends:
 libpocl1 (= ${binary:Version}),
 ${misc:Depends}
Provides:
 opencl-icd,
 opencl-icd-1.1-1,
 opencl-icd-1.2-1,
Description: pocl ICD
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package allows one to use pocl as an installable client driver (ICD) for
 OpenCL.

Package: libpocl1-common
Architecture: all
Multi-Arch: foreign
Section: utils
Depends:
 ${misc:Depends}
Description: common files for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the architecture independent files of the pocl library.

Package: libpocl1
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 libpocl1-common (= ${source:Version}),
 clang-${LLVM:Version},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 pocl-opencl-icd,
Breaks:
 libpocl1-common (<< 0.13-9),
Replaces:
 libpocl1-common (<< 0.13-9),
Description: Portable Computing Language library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the core of pocl.

Package: libpoclu1
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: utility library for writing OpenCL programs
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides an small utility library to help writing OpenCL
 programs.

Package: libpoclu-dev
Architecture: any
Section: libdevel
Depends:
 libpoclu1 (= ${binary:Version}),
 opencl-headers,
 ${misc:Depends}
Recommends:
 ocl-icd-opencl-dev,
Description: development files for the pocl utility library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the development files for the pocl utility library,
 that provides various facilities to write OpenCL programs.

Package: libpocl-dev
Architecture: any
Section: libdevel
Depends:
 libpocl1 (= ${binary:Version}),
 ${misc:Depends}
Description: development files for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the development files for the pocl library. Unless very
 specific needs, this package is useless. This package is only required to link
 directly and explicitly with pocl.
 .
 To develop OpenCL programs (that can be run with pocl), the opencl-dev virtual
 package (provided by ocl-icd-opencl-dev for example) is required, not this one.

Package: pocl-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the development files for the pocl library.  Unless very
 specific needs, this package is useless.  This package is only required to link
 directly and explicitly with pocl.
 .
 This package provides the documentation for the pocl library.
